//@target illustrator

//@include "killCEP.jsx"
//@include "openJsxFolder.jsx"

function addBtn (extPath) {
  var resultName = '',
      sourseJsx, targJsx,
      soursePng, targPng;

  var w          = new Window ('dialog', 'Add script button'),
      pn         = w.add('panel'),
      gr_addJsx  = pn.add('group'),
      gr_addPng  = pn.add('group'),
      gr_stdBtns = w.add('group'),

      btn_addJsx = gr_addJsx.add('button', undefined, 'Add jsx-script'),
      txt_addJsx = gr_addJsx.add('edittext'),

      btn_addPng = gr_addPng.add('button', undefined, 'Add png-image'),
      txt_addPng = gr_addPng.add('edittext'),

      btn_ok     = gr_stdBtns.add('button', undefined, 'Ok'),
      btn_cancel = gr_stdBtns.add('button', undefined, 'Cancel');

  txt_addJsx.characters = txt_addPng.characters = 40;
  btn_addPng.preferredSize.width = btn_addJsx.preferredSize.width = 120;

  btn_addPng.onClick = function () {
    soursePng       = File.openDialog ('Select a png-image file', 'PNG files:*.png', false);
    txt_addPng.text = soursePng.fullName;
  }

  btn_addJsx.onClick = function () {
    sourseJsx       = File.openDialog ('Select a jsx-script file', 'JSX files:*.jsx', false);
    txt_addJsx.text = sourseJsx.fullName;
  }

  btn_ok.onClick = function () {
    resultName = (sourseJsx.name).slice(0, -4);

    sourseJsx.copy(extPath + '/jsx/user/' + resultName + '_.jsx');
    targJsx = new File (extPath + '/jsx/user/' + resultName + '_.jsx');
    try {
      (new File (extPath + '/jsx/user/' + resultName + '.jsx')).remove();
    } catch (e) {
    }
    targJsx.rename(resultName + '.jsx');

    soursePng.copy(extPath + '/img/user/' + resultName + '_.png');
    targPng = new File (extPath + '/img/user/' + resultName + '_.png');
    try {
      (new File (extPath + '/img/user/' + resultName + '.png')).remove();
    } catch (e) {
    }
    targPng.rename(resultName + '.png');

    var f   = new File (extPath + '/jsx/cfg.cfg'),
        cfg = [];

    f.open('r');
    while (!f.eof) {
      cfg.push(f.readln());
    }
    f.close();

    cfg.push(resultName);

    f.open('w');
    for (var i = 0; i < cfg.length; i++) {
      f.writeln(cfg[i]);
    }
    f.close();

    w.close();
  }

  w.show();

  return resultName;
}

function delBtn (extPath, delName) {
  var f   = new File (extPath + '/jsx/cfg.cfg'),
      cfg = [],
      i;

  (new File (extPath + '/img/user/' + delName + '.png')).remove();
  (new File (extPath + '/jsx/user/' + delName + '.jsx')).remove();

  f.open('r');
  while (!f.eof) {
    cfg.push(f.readln());
  }
  f.close();

  for (var i = 0; i < cfg.length; i++) {
    if (cfg[i] == delName) {
      cfg.splice(i, 1);
      break;
    }
  }

  f.open('w');
  for (var i = 0; i < cfg.length; i++) {
    f.writeln(cfg[i]);
  }
  f.close();
}

function rCfg (fPath) {
  var f   = new File (fPath),
      res = [];

  f.open('r');

  while (!f.eof) {
    res.push(f.readln());
  }
  f.close();

  return JSON.stringify(res);
}
